import argparse
from linker import FlatLink, FlatConvert
from fake import fakeEnv
import sys
import copy
import numpy as np
import configparser
sys.path.append("flatland")
from flatland.envs.observations import LocalObsForRailEnv

from flatland.envs.rail_env import RailEnv
from flatland.envs.generators import random_rail_generator, complex_rail_generator
from flatland.core.env_observation_builder import ObservationBuilder
from flatland.core.transition_map import GridTransitionMap
from flatland.utils.rendertools import RenderTool
import time
import pickle


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('action', choices=['generate','play'])



    args = parser.parse_args()
    rt = None
    config = configparser.ConfigParser()
    config.read('flatland_a3c.ini')

    flatconfig = config['ENVIRONMENT']

    size_x=int(flatconfig['size_x'])
    size_y=int(flatconfig['size_y'])
    fov_size_x = int(flatconfig['fov_size_x'])
    fov_size_y = int(flatconfig['fov_size_y'])
    num_agents = int(flatconfig['num_agents'])
    num_extra = int(flatconfig['num_extra'])
    min_dist_ = int(flatconfig['min_dist_'])
    radius = int(flatconfig['radius'])
    gpu_=-1

    if config['GPU_SUPPORT'].getboolean('UseGpu'):
        gpu_ = int(config['GPU_SUPPORT']['GpuID'])
    

    link_ = FlatConvert(fov_size_x,fov_size_y,gpu_=gpu_)
    
    hyperparams = config['HYPERPARAMS']
    
    link_.play_epochs = int(hyperparams['play_epochs'])
    link_.n_step_return_ = int(hyperparams['n_step_return_'])
    link_.play_game_number = int(hyperparams['play_game_number'])
    link_.replay_buffer_size = int(hyperparams['replay_buffer_size'])
    link_.num_epochs = int(hyperparams['num_epochs'])
    link_.batch_size = int(hyperparams['batch_size'])
    link_.buffer_size = int(hyperparams['buffer_size'])
    link_.gamma_ = float(hyperparams['gamma_'])
    link_.thres = float(hyperparams['thres'])
    link_.rate_decay = float(hyperparams['rate_decay'])
    link_.min_thres = float(hyperparams['min_thres'])
    link_.buffer_threshold = float(hyperparams['buffer_threshold'])

    if args.action == 'generate':

        env = RailEnv(size_x,size_y,rail_generator=complex_rail_generator(num_agents,nr_extra=num_extra, min_dist=min_dist_,seed=12345),number_of_agents=num_agents,obs_builder_object=LocalObsForRailEnv(fov_size_x,fov_size_y,int(fov_size_x/2)))
        #env = RailEnv(size_x,size_y,rail_generator=complex_rail_generator(num_agents,20,5,seed=12345),number_of_agents=num_agents,obs_builder_object=RawFObservation())
        rt = RenderTool(env,gl="PILSVG")
        link_.perform_training(env,rt)
       
    elif args.action == 'play':
        
        env = RailEnv(size_x,size_y,rail_generator=complex_rail_generator(num_agents,nr_extra=num_extra, min_dist=min_dist_,seed=12345),number_of_agents=num_agents,obs_builder_object=LocalObsForRailEnv(fov_size_x,fov_size_y,int(fov_size_x/2)))

        link_.play(env,"models/model_a3c_o_15.pt")
